import ctypes
		
LEFT_5 = '1'
LEFT_4 = '2'
LEFT_3 = '3'
LEFT_2 = '4'
LEFT_1 = '5'
RIGHT_1 = '6'
RIGHT_2 = '7'
RIGHT_3 = '8'
RIGHT_4 = '9'
RIGHT_5 = '10'
CAPSLOCK = '11'
DELETE = '12'

class Tree:
	def __init__(self, data, queue=[], children=[], parent=None):
		self.data = data
		if queue:
			self.queue = queue
		else:
			self.queue = []
		self.parent = parent
		
		if children:
			self.children = children
			for child in children:
				child.parent = self
		else:
			self.children = []
		
		if parent:
			parent.children.append(self)
	
	def getNext(self, char):
		for child in self.children:
			if(child.data == char):
				return child
		return None
	
	def getPrev(self):
		return self.parent
	
	def __repr__(self):
		return self.data
	
	def _getLastChildOrSelf(self):
		try:
			return self.children[-1]._getLastChildOrSelf()
		except:
			return self
	
	def getBrothers(self):
		try:
			return self.parent.children
		except:
			return None
	
	def getChildren(self):
		return self.children

	def addChild(self,keyStroke,word):
		pointer = self
		for key in keyStroke:
			if( pointer.getNext(key) != None):
				#print 'Next node of ',pointer,' is ', pointer.getNext(key)
				pointer=pointer.getNext(key)
			else:
				leaf = Tree(key, parent=pointer)
				#print 'Next node of ',pointer,' is ', pointer.getNext(key)
				pointer=leaf
		
		ch = 0;
		
		for item in pointer.queue:
			if(item==word):
				ch=1
				break
		
		if(ch==0):
			pointer.queue.append(word)
	
#r= Tree('-1')

#l4 = Tree('1',['q','a','z'],parent=r)
#l3 = Tree('2',['w','s','x'],parent=r)
#l2 = Tree('3',['e','d','c'],parent=r)
#l1 = Tree('4',['r','f','v','t','g'],parent=r)
#l4l2 = Tree('3',['ad','ac'],parent=l4)

#r.addChild(['2','4','1','4'],'star')
#r.addChild(['3','1','4'],'car')
#r.addChild(['1','4','4'],'avr')

#print 'The node',r,' has child :',r.getChildren()
#print 'The node',l4,' has child :',l4.getChildren()

#print 'End of ',l3,' is ',l3._getLastChildOrSelf().queue
#print 'End of ',l2,' is ',l2._getLastChildOrSelf().queue
#print 'End of ',l4,' is ',l4._getLastChildOrSelf().queue

# print 'list of ',l4, ' is', l4.queue
# print 'Next node of ',l4,' is ', l4.getNext('L2')
# print 'Next node of ',l4,' has ', l4.getNext('L2').queue
# print 'Prev node of ',l4l2,'is ', l4l2.getPrev()